> ## Documentation Index
> Fetch the complete documentation index at: https://help.teable.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a base from template or apply a template to a base

> Create a base from template or apply a template to a base



## OpenAPI

````yaml /swagger.json post /base/create-from-template
openapi: 3.0.0
info:
  version: 1.0.0
  title: Teable App
  description: Manage Data as easy as drink a cup of tea
  x-logo:
    backgroundColor: '#F0F0F0'
    altText: Teable logo
servers:
  - url: https://app.teable.ai/api
security: []
paths:
  /base/create-from-template:
    post:
      tags:
        - base
      summary: Create a base from template or apply a template to a base
      description: Create a base from template or apply a template to a base
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                spaceId:
                  type: string
                  description: The space id to create a base from
                templateId:
                  type: string
                  description: The template id to create a base from
                withRecords:
                  type: boolean
                  description: Whether to create records from the template
                baseId:
                  type: string
                  description: The base id to apply the template to
              required:
                - spaceId
                - templateId
      responses:
        '201':
          description: Returns information about a successfully created base.
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                  name:
                    type: string
                  spaceId:
                    type: string
                  defaultUrl:
                    type: string
                required:
                  - id
                  - name
                  - spaceId
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: Shell
          source: |-
            curl --request POST \
              --url https://app.teable.ai/api/base/create-from-template \
              --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
              --header 'content-type: application/json' \
              --data '{"spaceId":"string","templateId":"string","withRecords":true,"baseId":"string"}'
        - lang: JavaScript
          source: |-
            const url = 'https://app.teable.ai/api/base/create-from-template';
            const options = {
              method: 'POST',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              },
              body: '{"spaceId":"string","templateId":"string","withRecords":true,"baseId":"string"}'
            };

            try {
              const response = await fetch(url, options);
              const data = await response.json();
              console.log(data);
            } catch (error) {
              console.error(error);
            }
        - lang: Node.js
          source: >-
            const http = require('https');


            const options = {
              method: 'POST',
              hostname: 'app.teable.ai',
              port: null,
              path: '/api/base/create-from-template',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              }
            };


            const req = http.request(options, function (res) {
              const chunks = [];

              res.on('data', function (chunk) {
                chunks.push(chunk);
              });

              res.on('end', function () {
                const body = Buffer.concat(chunks);
                console.log(body.toString());
              });
            });


            req.write(JSON.stringify({spaceId: 'string', templateId: 'string',
            withRecords: true, baseId: 'string'}));

            req.end();
        - lang: Python
          source: >-
            import http.client


            conn = http.client.HTTPSConnection("app.teable.ai")


            payload =
            "{\"spaceId\":\"string\",\"templateId\":\"string\",\"withRecords\":true,\"baseId\":\"string\"}"


            headers = {
                'Authorization': "Bearer REPLACE_BEARER_TOKEN",
                'content-type': "application/json"
            }


            conn.request("POST", "/api/base/create-from-template", payload,
            headers)


            res = conn.getresponse()

            data = res.read()


            print(data.decode("utf-8"))
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````